From: "Rollins, Jameson" <jrollins@caltech.edu>
To: Notmuch Mail <notmuch@notmuchmail.org>
Subject: [PATCH 3/3] tests: run all tests in parallel, if available
Date: Sat, 4 May 2019 20:57:43 +0000 [thread overview]
Message-ID: <20190504205738.21504-4-jrollins@caltech.edu> (raw)
In-Reply-To: <20190504205738.21504-3-jrollins@caltech.edu>
From: Jameson Graef Rollins <jrollins@finestructure.net>
If either the moreutils or GNU parallel utility are available, run all
tests in parallel. On my eight core machine this makes for a ~x7
speed-up in the full test suite (1m24s -> 12s).
The design of the test suite makes this parallelization trivial.
---
test/notmuch-test | 30 ++++++++++++++++++++----------
1 file changed, 20 insertions(+), 10 deletions(-)
diff --git a/test/notmuch-test b/test/notmuch-test
index 1a1ae811..a4b7a1eb 100755
--- a/test/notmuch-test
+++ b/test/notmuch-test
@@ -40,17 +40,27 @@ fi
trap 'e=$?; kill $!; exit $e' HUP INT TERM
# Run the tests
-for test in $TESTS; do
- $TEST_TIMEOUT_CMD $test "$@" &
- wait $!
- # If the test failed without producing results, then it aborted,
- # so we should abort, too.
- RES=$?
- testname=$(basename $test .sh)
- if [[ $RES != 0 && ! -e "$NOTMUCH_BUILDDIR/test/test-results/$testname" ]]; then
- exit $RES
+if command -v parallel >/dev/null ; then
+ if parallel -h | grep -q GNU ; then
+ echo "INFO: running tests with GNU parallel"
+ printf '%s\n' $TESTS | $TEST_TIMEOUT_CMD parallel
+ else
+ echo "INFO: running tests with moreutils parallel"
+ $TEST_TIMEOUT_CMD parallel -- $TESTS
fi
-done
+else
+ for test in $TESTS; do
+ $TEST_TIMEOUT_CMD $test "$@" &
+ wait $!
+ # If the test failed without producing results, then it aborted,
+ # so we should abort, too.
+ RES=$?
+ testname=$(basename $test .sh)
+ if [[ $RES != 0 && ! -e "$NOTMUCH_BUILDDIR/test/test-results/$testname" ]]; then
+ exit $RES
+ fi
+ done
+fi
trap - HUP INT TERM
# Report results
--
2.20.1
next prev parent reply other threads:[~2019-05-04 20:57 UTC|newest]
Thread overview: 22+ messages / expand[flat|nested] mbox.gz Atom feed top
2019-05-04 20:57 parallelize test suite Rollins, Jameson
2019-05-04 20:57 ` [PATCH 1/3] tests: remove some redundant pre-cleanup of the corpus MAIL_DIR Rollins, Jameson
2019-05-04 20:57 ` [PATCH 2/3] tests: remove entangling corpus index optimization Rollins, Jameson
2019-05-04 20:57 ` Rollins, Jameson [this message]
2019-05-06 4:44 ` [PATCH] tests: environment variable to specify that tests should be serialized Rollins, Jameson
2019-05-06 10:32 ` [PATCH] test: add configurable port to smtp-dummy David Bremner
2019-05-06 19:39 ` Tomi Ollila
2019-05-06 20:55 ` Daniel Kahn Gillmor
2019-05-07 10:20 ` [PATCH] test: let the OS choose a port for smtp-dummy David Bremner
2019-05-07 12:38 ` Daniel Kahn Gillmor
2019-05-08 15:59 ` Tomi Ollila
2019-05-10 10:16 ` David Bremner
2019-05-06 19:15 ` [PATCH] tests: environment variable to specify that tests should be serialized Tomi Ollila
2019-05-06 20:58 ` Daniel Kahn Gillmor
2019-05-05 10:22 ` [PATCH 1/3] tests: remove some redundant pre-cleanup of the corpus MAIL_DIR Tomi Ollila
2019-05-04 21:33 ` parallelize test suite Rollins, Jameson
2019-05-04 21:39 ` Daniel Kahn Gillmor
2019-05-04 22:53 ` David Bremner
2019-05-05 15:22 ` Daniel Kahn Gillmor
2019-05-05 16:44 ` Tomi Ollila
2019-05-06 21:39 ` Daniel Kahn Gillmor
2019-05-07 10:26 ` David Bremner
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
List information: https://notmuchmail.org/
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20190504205738.21504-4-jrollins@caltech.edu \
--to=jrollins@caltech.edu \
--cc=notmuch@notmuchmail.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
Code repositories for project(s) associated with this public inbox
https://yhetil.org/notmuch.git/
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).